stages:
  - lint
  - test
  - staging
  - release

variables:
  MYSQL_DATABASE: pastell_test
  MYSQL_USER: user
  MYSQL_PASSWORD: user
  MYSQL_RANDOM_ROOT_PASSWORD: "yes"
  MYSQL_HOST_TEST: 'mysql'
  MYSQL_HOST: 'mysql'
  MYSQL_PORT: '3306'
  PASTELL_SITE_BASE: 'https://localhost/'
  EXTENSION_NAME: pastell-sitiv

lint:
  stage: lint
  image : php:8.1-cli
  before_script:
    - apt-get update
    - apt-get install zip unzip git libxml2-dev zlib1g-dev libzip-dev -yqq
    - php -r "copy('https://getcomposer.org/installer', 'composer-setup.php');"
    - docker-php-ext-install soap zip
    - php composer-setup.php
    - php -r "unlink('composer-setup.php');"
    - php composer.phar install
  script:
    - php composer.phar phpcs

unit_test:
  stage: test
  image : gitlab.libriciel.fr:4567/libriciel/pole-plate-formes/pastell/pastell:4.0.9
  variables:
    XDEBUG_ON: "true"
    COMPOSER_PROCESS_TIMEOUT: 1200
    DONT_RETRIEVE_VALIDCA: "true"
    MYSQL_DATABASE: pastell_test
    MYSQL_USER: user
    MYSQL_PASSWORD: user
    MYSQL_RANDOM_ROOT_PASSWORD: "yes"
    MYSQL_HOST_TEST: 'mariadb'
    MYSQL_HOST: 'mariadb'
    MYSQL_PORT: '3306'
    PASTELL_SITE_BASE: 'https://localhost/'
    WEBSEC_BASE: https://127.0.0.1/
  services:
    - name: hubdocker.libriciel.fr/mariadb:10.9.3-jammy
      alias: mariadb
  script:
    - composer install
    - phpunit --coverage-text --colors=never --coverage-clover coverage/coverage.xml --log-junit coverage/logfile.xml


release:
  stage: release
  image : php:8.1-cli
  only:
    - tags
  variables:
    TARBALL_NAME: $EXTENSION_NAME-${CI_COMMIT_REF_NAME}.tar.gz
    PAYLOAD: "payload={\"text\": \"[$EXTENSION_NAME] Création de la version [$CI_COMMIT_REF_NAME](http://ressources.libriciel.fr/pastell/extensions/$EXTENSION_NAME-${CI_COMMIT_REF_NAME}.tar.gz)\"}"
  before_script:
    - apt-get -qq update && apt-get -yqq install openssh-client lftp libzip-dev libxml2-dev
    - mkdir -p ~/.ssh
    - echo -e "Host *\n\tStrictHostKeyChecking no\n\n" > ~/.ssh/config
    - php -r "copy('https://getcomposer.org/installer', 'composer-setup.php');"
    - docker-php-ext-install soap zip
    - php composer-setup.php
    - php -r "unlink('composer-setup.php');"
  script:
    - date=$(date)
    - sed -i "s/%CI_BUILD_ID%/${CI_PIPELINE_ID}/" ./manifest.yml
    - sed -i "s/%BUILD_DATE%/$date/" ./manifest.yml
    - sed -i "s/%VERSION%/${CI_COMMIT_REF_NAME}/" ./manifest.yml
    - php composer.phar install
    - cd ${CI_PROJECT_DIR}
    - cd ..
    - tar cvzf  /tmp/${TARBALL_NAME} --exclude-vcs $EXTENSION_NAME
    - cp /tmp/${TARBALL_NAME} ${CI_PROJECT_DIR}
    - lftp -p 2222 -u "pastell","${RESSOURCE_LIBRICIEL_FTP_PASSWD}"  "sftp://ressources.libriciel.fr/pastell/extensions/" -e "put /tmp/${TARBALL_NAME}; bye"
    - curl -i -X POST -d "$PAYLOAD" $MATTERMOST_WEBHOOK
  artifacts:
    paths:
      - ${TARBALL_NAME}